<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: Task.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Task.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Task.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: Mar 4, 2017</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef COMPONENTS_CPP_UTILS_TASK_H_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define COMPONENTS_CPP_UTILS_TASK_H_</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;freertos/FreeRTOS.h&gt;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;freertos/task.h&gt;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="classTask.html">   34</a></span>&#160;<span class="keyword">class </span><a class="code" href="classTask.html">Task</a> {</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <a class="code" href="classTask.html#a3db47e6fe693170a64a636ee93a1f645">Task</a>(std::string taskName = <span class="stringliteral">&quot;Task&quot;</span>, uint16_t stackSize = 10000, uint8_t priority = 5);</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keyword">virtual</span> ~<a class="code" href="classTask.html">Task</a>();</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classTask.html#afe0f5594c56b8cc7ac96c2198d5d81b4">setStackSize</a>(uint16_t stackSize);</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classTask.html#aaa220be4e5007ede0bd3e5349d36eae9">setPriority</a>(uint8_t priority);</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classTask.html#a23abd79183a5c2bb1e6d3ff37b1cbf23">setName</a>(std::string name);</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classTask.html#a5ec932fb35fd295c78eafcf06af1d91d">setCore</a>(BaseType_t coreId);</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classTask.html#a6f13d13787e21dc929b61d112b863433">start</a>(<span class="keywordtype">void</span>* taskData = <span class="keyword">nullptr</span>);</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classTask.html#aba5eb3d6c2a034aa0e319383fbec68c4">stop</a>();</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classTask.html#a399f60ad8cd91d34dba2de57b4ac6d65">run</a>(<span class="keywordtype">void</span>* data) = 0; <span class="comment">// Make run pure virtual</span></div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classTask.html#aa4b603c866f4b8e0f0c6b524bb0e287e">delay</a>(<span class="keywordtype">int</span> ms);</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    xTaskHandle m_handle;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keywordtype">void</span>*       m_taskData;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> runTask(<span class="keywordtype">void</span>* data);</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    std::string m_taskName;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    uint16_t    m_stackSize;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    uint8_t     m_priority;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    BaseType_t  m_coreId;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;};</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* COMPONENTS_CPP_UTILS_TASK_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="classTask_html_aa4b603c866f4b8e0f0c6b524bb0e287e"><div class="ttname"><a href="classTask.html#aa4b603c866f4b8e0f0c6b524bb0e287e">Task::delay</a></div><div class="ttdeci">static void delay(int ms)</div><div class="ttdoc">Suspend the task for the specified milliseconds.</div><div class="ttdef"><b>Definition:</b> Task.cpp:46</div></div>
<div class="ttc" id="classTask_html_afe0f5594c56b8cc7ac96c2198d5d81b4"><div class="ttname"><a href="classTask.html#afe0f5594c56b8cc7ac96c2198d5d81b4">Task::setStackSize</a></div><div class="ttdeci">void setStackSize(uint16_t stackSize)</div><div class="ttdoc">Set the stack size of the task.</div><div class="ttdef"><b>Definition:</b> Task.cpp:97</div></div>
<div class="ttc" id="classTask_html_a23abd79183a5c2bb1e6d3ff37b1cbf23"><div class="ttname"><a href="classTask.html#a23abd79183a5c2bb1e6d3ff37b1cbf23">Task::setName</a></div><div class="ttdeci">void setName(std::string name)</div><div class="ttdoc">Set the name of the task.</div><div class="ttdef"><b>Definition:</b> Task.cpp:117</div></div>
<div class="ttc" id="classTask_html_aaa220be4e5007ede0bd3e5349d36eae9"><div class="ttname"><a href="classTask.html#aaa220be4e5007ede0bd3e5349d36eae9">Task::setPriority</a></div><div class="ttdeci">void setPriority(uint8_t priority)</div><div class="ttdoc">Set the priority of the task.</div><div class="ttdef"><b>Definition:</b> Task.cpp:107</div></div>
<div class="ttc" id="classTask_html_a5ec932fb35fd295c78eafcf06af1d91d"><div class="ttname"><a href="classTask.html#a5ec932fb35fd295c78eafcf06af1d91d">Task::setCore</a></div><div class="ttdeci">void setCore(BaseType_t coreId)</div><div class="ttdoc">Set the core number the task has to be executed on. If the core number is not set,...</div><div class="ttdef"><b>Definition:</b> Task.cpp:128</div></div>
<div class="ttc" id="classTask_html_aba5eb3d6c2a034aa0e319383fbec68c4"><div class="ttname"><a href="classTask.html#aba5eb3d6c2a034aa0e319383fbec68c4">Task::stop</a></div><div class="ttdeci">void stop()</div><div class="ttdoc">Stop the task.</div><div class="ttdef"><b>Definition:</b> Task.cpp:84</div></div>
<div class="ttc" id="classTask_html_a399f60ad8cd91d34dba2de57b4ac6d65"><div class="ttname"><a href="classTask.html#a399f60ad8cd91d34dba2de57b4ac6d65">Task::run</a></div><div class="ttdeci">virtual void run(void *data)=0</div><div class="ttdoc">Body of the task to execute.</div></div>
<div class="ttc" id="classTask_html_a3db47e6fe693170a64a636ee93a1f645"><div class="ttname"><a href="classTask.html#a3db47e6fe693170a64a636ee93a1f645">Task::Task</a></div><div class="ttdeci">Task(std::string taskName=&quot;Task&quot;, uint16_t stackSize=10000, uint8_t priority=5)</div><div class="ttdoc">Create an instance of the task class.</div><div class="ttdef"><b>Definition:</b> Task.cpp:27</div></div>
<div class="ttc" id="classTask_html_a6f13d13787e21dc929b61d112b863433"><div class="ttname"><a href="classTask.html#a6f13d13787e21dc929b61d112b863433">Task::start</a></div><div class="ttdeci">void start(void *taskData=nullptr)</div><div class="ttdoc">Start an instance of the task.</div><div class="ttdef"><b>Definition:</b> Task.cpp:70</div></div>
<div class="ttc" id="classTask_html"><div class="ttname"><a href="classTask.html">Task</a></div><div class="ttdoc">Encapsulate a runnable task.</div><div class="ttdef"><b>Definition:</b> Task.h:34</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
